/*****************************************************************

Copyright (c) 2002 John Firebaugh <jfirebaugh@kde.org>

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************/

#ifndef __PanelManager_h__
#define __PanelManager_h__

// Fix compilation with --enable-final
#ifdef None
#undef None
#endif
 
#include <qobject.h>
#include <qptrlist.h>

class PanelContainer;

typedef QPtrListIterator<PanelContainer> PanelListIterator;

class PanelManager : public QObject
{
	Q_OBJECT
public:
	static PanelManager* the();

	const QPtrList<PanelContainer>& panels() { return _panels; }

	void add( PanelContainer* panel );
	void remove( PanelContainer* panel );

	void raise( PanelContainer* panel );
	int stackingPosition( PanelContainer* panel );

	void readConfig();
	void writeConfig();

	void showAll();
	void shutdown();

private:
	PanelManager();

	QPtrList<PanelContainer> _panels;
};

#endif
